import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import { Phases, symbol } from './constants';
export var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_ref) {
    var promise, createQuery, transformEvents, queryExecutor, updateResult, result;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents;

            if (!(promise[symbol].phase < Phases.RESOLVER)) {
              _context.next = 3;
              break;
            }

            throw new TypeError(promise[symbol].phase);

          case 3:
            queryExecutor = null;
            _context.prev = 4;
            queryExecutor = createQuery({
              viewModels: [],
              readModels: [{
                name: promise[symbol].name,
                projection: promise[symbol].projection,
                resolvers: promise[symbol].resolvers,
                connectorName: 'ADAPTER_NAME'
              }],
              readModelConnectors: {
                ADAPTER_NAME: promise[symbol].adapter
              },
              getRemainingTimeInMillis: function getRemainingTimeInMillis() {
                return 0x7fffffff;
              },
              snapshotAdapter: null,
              eventstoreAdapter: {
                getSecretsManager: function getSecretsManager() {
                  return promise[symbol].secretsManager;
                }
              }
            });
            updateResult = null;
            _context.prev = 7;
            _context.next = 10;
            return queryExecutor.sendEvents({
              modelName: promise[symbol].name,
              events: transformEvents(promise[symbol].events)
            });

          case 10:
            updateResult = _context.sent;
            _context.next = 16;
            break;

          case 13:
            _context.prev = 13;
            _context.t0 = _context["catch"](7);
            updateResult = _context.t0;

          case 16:
            if (!(updateResult != null && updateResult.lastError != null)) {
              _context.next = 18;
              break;
            }

            throw updateResult.lastError;

          case 18:
            _context.next = 20;
            return queryExecutor.read({
              modelName: promise[symbol].name,
              resolverName: promise[symbol].resolverName,
              resolverArgs: promise[symbol].resolverArgs,
              jwt: promise[symbol].jwt
            });

          case 20:
            result = _context.sent;
            promise[symbol].resolve(result);
            _context.next = 27;
            break;

          case 24:
            _context.prev = 24;
            _context.t1 = _context["catch"](4);
            promise[symbol].reject(_context.t1);

          case 27:
            _context.prev = 27;

            if (!queryExecutor) {
              _context.next = 31;
              break;
            }

            _context.next = 31;
            return queryExecutor.dispose();

          case 31:
            return _context.finish(27);

          case 32:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[4, 24, 27, 32], [7, 13]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();
//# sourceMappingURL=execute-read-model.js.map