"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.executeReadModel = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _constants = require("./constants");

var executeReadModel = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(_ref) {
    var promise, createQuery, transformEvents, queryExecutor, updateResult, result;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            promise = _ref.promise, createQuery = _ref.createQuery, transformEvents = _ref.transformEvents;

            if (!(promise[_constants.symbol].phase < _constants.Phases.RESOLVER)) {
              _context.next = 3;
              break;
            }

            throw new TypeError(promise[_constants.symbol].phase);

          case 3:
            queryExecutor = null;
            _context.prev = 4;
            queryExecutor = createQuery({
              viewModels: [],
              readModels: [{
                name: promise[_constants.symbol].name,
                projection: promise[_constants.symbol].projection,
                resolvers: promise[_constants.symbol].resolvers,
                connectorName: 'ADAPTER_NAME'
              }],
              readModelConnectors: {
                ADAPTER_NAME: promise[_constants.symbol].adapter
              },
              getRemainingTimeInMillis: function getRemainingTimeInMillis() {
                return 0x7fffffff;
              },
              snapshotAdapter: null,
              eventstoreAdapter: {
                getSecretsManager: function getSecretsManager() {
                  return promise[_constants.symbol].secretsManager;
                }
              }
            });
            updateResult = null;
            _context.prev = 7;
            _context.next = 10;
            return queryExecutor.sendEvents({
              modelName: promise[_constants.symbol].name,
              events: transformEvents(promise[_constants.symbol].events)
            });

          case 10:
            updateResult = _context.sent;
            _context.next = 16;
            break;

          case 13:
            _context.prev = 13;
            _context.t0 = _context["catch"](7);
            updateResult = _context.t0;

          case 16:
            if (!(updateResult != null && updateResult.lastError != null)) {
              _context.next = 18;
              break;
            }

            throw updateResult.lastError;

          case 18:
            _context.next = 20;
            return queryExecutor.read({
              modelName: promise[_constants.symbol].name,
              resolverName: promise[_constants.symbol].resolverName,
              resolverArgs: promise[_constants.symbol].resolverArgs,
              jwt: promise[_constants.symbol].jwt
            });

          case 20:
            result = _context.sent;

            promise[_constants.symbol].resolve(result);

            _context.next = 27;
            break;

          case 24:
            _context.prev = 24;
            _context.t1 = _context["catch"](4);

            promise[_constants.symbol].reject(_context.t1);

          case 27:
            _context.prev = 27;

            if (!queryExecutor) {
              _context.next = 31;
              break;
            }

            _context.next = 31;
            return queryExecutor.dispose();

          case 31:
            return _context.finish(27);

          case 32:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[4, 24, 27, 32], [7, 13]]);
  }));

  return function executeReadModel(_x) {
    return _ref2.apply(this, arguments);
  };
}();

exports.executeReadModel = executeReadModel;
//# sourceMappingURL=execute-read-model.js.map